/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  Contract,
  ContractTransaction,
  Overrides,
  PayableOverrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import { TypedEventFilter, TypedEvent, TypedListener } from "./commons";

interface IAvatarListingInterface extends ethers.utils.Interface {
  functions: {
    "cancelListing(uint256)": FunctionFragment;
    "createBid(uint256,uint256)": FunctionFragment;
    "createListing(uint256,address,uint256,uint256,uint256,uint8,address,uint8,address)": FunctionFragment;
    "endFixedPriceListing(uint256,uint256)": FunctionFragment;
    "endListing(uint256)": FunctionFragment;
    "setListingApproval(uint256,bool)": FunctionFragment;
    "setListingDropApproval(uint256,bool,uint256)": FunctionFragment;
    "setListingListPrice(uint256,uint256)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "cancelListing",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "createBid",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "createListing",
    values: [
      BigNumberish,
      string,
      BigNumberish,
      BigNumberish,
      BigNumberish,
      BigNumberish,
      string,
      BigNumberish,
      string
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "endFixedPriceListing",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "endListing",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "setListingApproval",
    values: [BigNumberish, boolean]
  ): string;
  encodeFunctionData(
    functionFragment: "setListingDropApproval",
    values: [BigNumberish, boolean, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "setListingListPrice",
    values: [BigNumberish, BigNumberish]
  ): string;

  decodeFunctionResult(
    functionFragment: "cancelListing",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "createBid", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "createListing",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "endFixedPriceListing",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "endListing", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setListingApproval",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setListingDropApproval",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setListingListPrice",
    data: BytesLike
  ): Result;

  events: {
    "ListingApprovalUpdated(uint256,uint256,address,bool)": EventFragment;
    "ListingBid(uint256,uint256,address,address,uint256,bool,bool)": EventFragment;
    "ListingCanceled(uint256,uint256,address,address)": EventFragment;
    "ListingCreated(uint256,uint256,address,uint256,uint256,uint256,uint8,address,address,uint8,address)": EventFragment;
    "ListingDropApprovalUpdated(uint256,uint256,address,bool,uint256)": EventFragment;
    "ListingDurationExtended(uint256,uint256,address,uint256)": EventFragment;
    "ListingEnded(uint256,uint256,address,address,address,address,uint256,uint256,address)": EventFragment;
    "ListingListPriceUpdated(uint256,uint256,address,uint256)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "ListingApprovalUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ListingBid"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ListingCanceled"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ListingCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ListingDropApprovalUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ListingDurationExtended"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ListingEnded"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ListingListPriceUpdated"): EventFragment;
}

export class IAvatarListing extends Contract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: IAvatarListingInterface;

  functions: {
    cancelListing(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "cancelListing(uint256)"(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    createBid(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "createBid(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    createListing(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "createListing(uint256,address,uint256,uint256,uint256,uint8,address,uint8,address)"(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    endFixedPriceListing(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "endFixedPriceListing(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    endListing(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "endListing(uint256)"(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setListingApproval(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "setListingApproval(uint256,bool)"(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setListingDropApproval(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "setListingDropApproval(uint256,bool,uint256)"(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setListingListPrice(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "setListingListPrice(uint256,uint256)"(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;
  };

  cancelListing(
    listingId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "cancelListing(uint256)"(
    listingId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  createBid(
    listingId: BigNumberish,
    amount: BigNumberish,
    overrides?: PayableOverrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "createBid(uint256,uint256)"(
    listingId: BigNumberish,
    amount: BigNumberish,
    overrides?: PayableOverrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  createListing(
    tokenId: BigNumberish,
    tokenContract: string,
    startsAt: BigNumberish,
    duration: BigNumberish,
    listPrice: BigNumberish,
    listType: BigNumberish,
    intermediary: string,
    intermediaryFeePercentages: BigNumberish,
    listCurrency: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "createListing(uint256,address,uint256,uint256,uint256,uint8,address,uint8,address)"(
    tokenId: BigNumberish,
    tokenContract: string,
    startsAt: BigNumberish,
    duration: BigNumberish,
    listPrice: BigNumberish,
    listType: BigNumberish,
    intermediary: string,
    intermediaryFeePercentages: BigNumberish,
    listCurrency: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  endFixedPriceListing(
    listingId: BigNumberish,
    amount: BigNumberish,
    overrides?: PayableOverrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "endFixedPriceListing(uint256,uint256)"(
    listingId: BigNumberish,
    amount: BigNumberish,
    overrides?: PayableOverrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  endListing(
    listingId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "endListing(uint256)"(
    listingId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setListingApproval(
    listingId: BigNumberish,
    approved: boolean,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "setListingApproval(uint256,bool)"(
    listingId: BigNumberish,
    approved: boolean,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setListingDropApproval(
    listingId: BigNumberish,
    approved: boolean,
    startsAt: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "setListingDropApproval(uint256,bool,uint256)"(
    listingId: BigNumberish,
    approved: boolean,
    startsAt: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setListingListPrice(
    listingId: BigNumberish,
    listPrice: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "setListingListPrice(uint256,uint256)"(
    listingId: BigNumberish,
    listPrice: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    cancelListing(
      listingId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    "cancelListing(uint256)"(
      listingId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    createBid(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    "createBid(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    createListing(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "createListing(uint256,address,uint256,uint256,uint256,uint8,address,uint8,address)"(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    endFixedPriceListing(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    "endFixedPriceListing(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    endListing(
      listingId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    "endListing(uint256)"(
      listingId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    setListingApproval(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: CallOverrides
    ): Promise<void>;

    "setListingApproval(uint256,bool)"(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: CallOverrides
    ): Promise<void>;

    setListingDropApproval(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    "setListingDropApproval(uint256,bool,uint256)"(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    setListingListPrice(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    "setListingListPrice(uint256,uint256)"(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {
    ListingApprovalUpdated(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      approved: null
    ): TypedEventFilter<
      [BigNumber, BigNumber, string, boolean],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        approved: boolean;
      }
    >;

    ListingBid(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      sender: null,
      value: null,
      firstBid: null,
      extended: null
    ): TypedEventFilter<
      [BigNumber, BigNumber, string, string, BigNumber, boolean, boolean],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        sender: string;
        value: BigNumber;
        firstBid: boolean;
        extended: boolean;
      }
    >;

    ListingCanceled(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      tokenOwner: null
    ): TypedEventFilter<
      [BigNumber, BigNumber, string, string],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        tokenOwner: string;
      }
    >;

    ListingCreated(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      startsAt: null,
      duration: null,
      listPrice: null,
      listType: null,
      tokenOwner: null,
      intermediary: null,
      intermediaryFeePercentage: null,
      listCurrency: null
    ): TypedEventFilter<
      [
        BigNumber,
        BigNumber,
        string,
        BigNumber,
        BigNumber,
        BigNumber,
        number,
        string,
        string,
        number,
        string
      ],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        startsAt: BigNumber;
        duration: BigNumber;
        listPrice: BigNumber;
        listType: number;
        tokenOwner: string;
        intermediary: string;
        intermediaryFeePercentage: number;
        listCurrency: string;
      }
    >;

    ListingDropApprovalUpdated(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      approved: null,
      startsAt: null
    ): TypedEventFilter<
      [BigNumber, BigNumber, string, boolean, BigNumber],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        approved: boolean;
        startsAt: BigNumber;
      }
    >;

    ListingDurationExtended(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      duration: null
    ): TypedEventFilter<
      [BigNumber, BigNumber, string, BigNumber],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        duration: BigNumber;
      }
    >;

    ListingEnded(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      tokenOwner: null,
      intermediary: null,
      winner: null,
      amount: null,
      intermediaryFee: null,
      listCurrency: null
    ): TypedEventFilter<
      [
        BigNumber,
        BigNumber,
        string,
        string,
        string,
        string,
        BigNumber,
        BigNumber,
        string
      ],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        tokenOwner: string;
        intermediary: string;
        winner: string;
        amount: BigNumber;
        intermediaryFee: BigNumber;
        listCurrency: string;
      }
    >;

    ListingListPriceUpdated(
      listingId: BigNumberish | null,
      tokenId: BigNumberish | null,
      tokenContract: string | null,
      listPrice: null
    ): TypedEventFilter<
      [BigNumber, BigNumber, string, BigNumber],
      {
        listingId: BigNumber;
        tokenId: BigNumber;
        tokenContract: string;
        listPrice: BigNumber;
      }
    >;
  };

  estimateGas: {
    cancelListing(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "cancelListing(uint256)"(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    createBid(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "createBid(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    createListing(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "createListing(uint256,address,uint256,uint256,uint256,uint8,address,uint8,address)"(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    endFixedPriceListing(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "endFixedPriceListing(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    endListing(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "endListing(uint256)"(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setListingApproval(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "setListingApproval(uint256,bool)"(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setListingDropApproval(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "setListingDropApproval(uint256,bool,uint256)"(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setListingListPrice(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "setListingListPrice(uint256,uint256)"(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    cancelListing(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "cancelListing(uint256)"(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    createBid(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "createBid(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    createListing(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "createListing(uint256,address,uint256,uint256,uint256,uint8,address,uint8,address)"(
      tokenId: BigNumberish,
      tokenContract: string,
      startsAt: BigNumberish,
      duration: BigNumberish,
      listPrice: BigNumberish,
      listType: BigNumberish,
      intermediary: string,
      intermediaryFeePercentages: BigNumberish,
      listCurrency: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    endFixedPriceListing(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "endFixedPriceListing(uint256,uint256)"(
      listingId: BigNumberish,
      amount: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    endListing(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "endListing(uint256)"(
      listingId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setListingApproval(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "setListingApproval(uint256,bool)"(
      listingId: BigNumberish,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setListingDropApproval(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "setListingDropApproval(uint256,bool,uint256)"(
      listingId: BigNumberish,
      approved: boolean,
      startsAt: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setListingListPrice(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "setListingListPrice(uint256,uint256)"(
      listingId: BigNumberish,
      listPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;
  };
}
